angular.module('focaModalTransportista')
    .controller('focaModalTransportistaController', 
        [
            '$filter',
            '$scope',
            '$uibModalInstance',
            'focaModalTransportistaService',
            function($filter, $scope, $uibModalInstance,
                focaModalTransportistaService
            ) {

                $scope.filters = '';
                $scope.transportistas = [];
                $scope.primerBusqueda = false;
                $scope.searchLoading = false;
                // pagination
                $scope.numPerPage = 10;
                $scope.currentPage = 1;
                $scope.filteredTransportistas = [];
                $scope.currentPageTransportistas = [];
                $scope.selectedTransportista = -1;

                //METODOS
                $scope.busquedaPress = function(key) {
                    if (key === 13) {
                        $scope.searchLoading = true;
                        focaModalTransportistaService.getTransportistas().then(llenarDatos);
                    }
                };
                function llenarDatos(res) {
                    $scope.searchLoading = false;
                    $scope.primerBusqueda = true;
                    $scope.transportistas = res.data;
                    $scope.search();
                    primera();
                }
                $scope.search = function() {
                    if($scope.transportistas.length > 0) {
                        $scope.filteredTransportistas = $filter('filter')(
                            $scope.transportistas,
                            {$: $scope.filters}
                        );

                        $scope.lastPage = Math.ceil(
                            $scope.filteredTransportistas.length / $scope.numPerPage
                        );

                        $scope.resetPage();
                    }
                };

                $scope.resetPage = function() {
                    $scope.currentPage = 1;
                    $scope.selectPage(1);
                };

                $scope.selectPage = function(page) {
                    var start = (page - 1) * $scope.numPerPage;
                    var end = start + $scope.numPerPage;
                    $scope.paginas = [];
                    $scope.paginas = calcularPages(page);
                    $scope.currentPageTransportistas =
                        $scope.filteredTransportistas.slice(start, end);
                    $scope.currentPage = page;
                };

                $scope.select = function(transportista) {
                    $uibModalInstance.close(transportista);
                };

                $scope.cancel = function() {
                    $uibModalInstance.dismiss('cancel');
                };

                $scope.busquedaDown = function(key) {
                    if (key === 40) {
                        primera(key);
                    }
                };

                $scope.itemTransportista = function(key) {
                    if (key === 38) {
                        anterior(key);
                    }

                    if (key === 40) {
                        siguiente(key);
                    }

                    if (key === 37) {
                        retrocederPagina();
                    }

                    if (key === 39) {
                        avanzarPagina();
                    }
                };

                function calcularPages(paginaActual) {
                    var paginas = [];
                    paginas.push(paginaActual);

                    if (paginaActual - 1 > 1) {
                        
                        paginas.unshift(paginaActual - 1);
                        if (paginaActual - 2 > 1) {
                            paginas.unshift(paginaActual - 2);
                        }
                    }

                    if (paginaActual + 1 < $scope.lastPage) {
                        paginas.push(paginaActual + 1);
                        if (paginaActual + 2 < $scope.lastPage) {
                            paginas.push(paginaActual + 2);
                        }
                    }

                    if (paginaActual !== 1) {
                        paginas.unshift(1);
                    }

                    if (paginaActual !== $scope.lastPage) {
                        paginas.push($scope.lastPage);
                    }

                    return paginas;
                }

                function primera() {
                    $scope.selectedTransportista = 0;
                }

                function anterior() {
                    if ($scope.selectedTransportista === 0 && $scope.currentPage > 1) {
                        retrocederPagina();
                    } else {
                        $scope.selectedTransportista--;
                    }
                }

                function siguiente() {
                    if (
                        $scope.selectedTransportista < $scope.currentPageTransportistas.length - 1
                    ) {
                        $scope.selectedTransportista++;
                    } else {
                            avanzarPagina();
                    }
                }

                function retrocederPagina() {
                    if ($scope.currentPage > 1) {
                        $scope.selectPage($scope.currentPage - 1);
                        $scope.selectedTransportista = $scope.numPerPage - 1;
                    }
                }

                function avanzarPagina() {
                    if ($scope.currentPage < $scope.lastPage) {
                        $scope.selectPage($scope.currentPage + 1);
                        $scope.selectedTransportista = 0;
                    }
                }
            }
        ]
    );
